
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class AddressesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const addresses = await db.addresses.create(
            {
                id: data.id || undefined,
        
        label: data.label
        ||
        null
            ,
            
        recipient_name: data.recipient_name
        ||
        null
            ,
            
        phone_number: data.phone_number
        ||
        null
            ,
            
        country: data.country
        ||
        null
            ,
            
        province: data.province
        ||
        null
            ,
            
        city: data.city
        ||
        null
            ,
            
        district: data.district
        ||
        null
            ,
            
        postal_code: data.postal_code
        ||
        null
            ,
            
        street_address: data.street_address
        ||
        null
            ,
            
        latitude: data.latitude
        ||
        null
            ,
            
        longitude: data.longitude
        ||
        null
            ,
            
        is_default: data.is_default
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await addresses.setUser( data.user || null, {
            transaction,
        });
        
        await addresses.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return addresses;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const addressesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                label: item.label
            ||
            null
            ,
            
                recipient_name: item.recipient_name
            ||
            null
            ,
            
                phone_number: item.phone_number
            ||
            null
            ,
            
                country: item.country
            ||
            null
            ,
            
                province: item.province
            ||
            null
            ,
            
                city: item.city
            ||
            null
            ,
            
                district: item.district
            ||
            null
            ,
            
                postal_code: item.postal_code
            ||
            null
            ,
            
                street_address: item.street_address
            ||
            null
            ,
            
                latitude: item.latitude
            ||
            null
            ,
            
                longitude: item.longitude
            ||
            null
            ,
            
                is_default: item.is_default
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const addresses = await db.addresses.bulkCreate(addressesData, { transaction });

        // For each item created, replace relation files
        

        return addresses;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const addresses = await db.addresses.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.label !== undefined) updatePayload.label = data.label;
        
        
        if (data.recipient_name !== undefined) updatePayload.recipient_name = data.recipient_name;
        
        
        if (data.phone_number !== undefined) updatePayload.phone_number = data.phone_number;
        
        
        if (data.country !== undefined) updatePayload.country = data.country;
        
        
        if (data.province !== undefined) updatePayload.province = data.province;
        
        
        if (data.city !== undefined) updatePayload.city = data.city;
        
        
        if (data.district !== undefined) updatePayload.district = data.district;
        
        
        if (data.postal_code !== undefined) updatePayload.postal_code = data.postal_code;
        
        
        if (data.street_address !== undefined) updatePayload.street_address = data.street_address;
        
        
        if (data.latitude !== undefined) updatePayload.latitude = data.latitude;
        
        
        if (data.longitude !== undefined) updatePayload.longitude = data.longitude;
        
        
        if (data.is_default !== undefined) updatePayload.is_default = data.is_default;
        
        
        updatePayload.updatedById = currentUser.id;

        await addresses.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await addresses.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await addresses.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return addresses;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const addresses = await db.addresses.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of addresses) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of addresses) {
                await record.destroy({transaction});
            }
        });


        return addresses;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const addresses = await db.addresses.findByPk(id, options);

        await addresses.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await addresses.destroy({
            transaction
        });

        return addresses;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const addresses = await db.addresses.findOne(
            { where },
            { transaction },
        );

        if (!addresses) {
            return addresses;
        }

        const output = addresses.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        output.stores_primary_address = await addresses.getStores_primary_address({
            transaction
        });
        
        
        
        
        
        output.orders_shipping_address = await addresses.getOrders_shipping_address({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.job_companies_hq_address = await addresses.getJob_companies_hq_address({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await addresses.getUser({
            transaction
        });
        
        
        output.organizations = await addresses.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.label) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'label',
                        filter.label,
                    ),
                };
            }
            
            if (filter.recipient_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'recipient_name',
                        filter.recipient_name,
                    ),
                };
            }
            
            if (filter.phone_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'phone_number',
                        filter.phone_number,
                    ),
                };
            }
            
            if (filter.country) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'country',
                        filter.country,
                    ),
                };
            }
            
            if (filter.province) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'province',
                        filter.province,
                    ),
                };
            }
            
            if (filter.city) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'city',
                        filter.city,
                    ),
                };
            }
            
            if (filter.district) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'district',
                        filter.district,
                    ),
                };
            }
            
            if (filter.postal_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'postal_code',
                        filter.postal_code,
                    ),
                };
            }
            
            if (filter.street_address) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'addresses',
                        'street_address',
                        filter.street_address,
                    ),
                };
            }
            

            
            

            
            if (filter.latitudeRange) {
                const [start, end] = filter.latitudeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    latitude: {
                    ...where.latitude,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    latitude: {
                    ...where.latitude,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.longitudeRange) {
                const [start, end] = filter.longitudeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    longitude: {
                    ...where.longitude,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    longitude: {
                    ...where.longitude,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_default) {
                where = {
                    ...where,
                is_default: filter.is_default,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.addresses.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'addresses',
                        'label',
                        query,
                    ),
                ],
            };
        }

        const records = await db.addresses.findAll({
            attributes: [ 'id', 'label' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['label', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.label,
        }));
    }

    
};

